/**
 * This class was orginally created by <Vazkii>.
 */
package xyz.brassgoggledcoders.boilerplate.client.manual;

import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.FontRenderer;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.Tessellator;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;
import net.minecraft.client.settings.KeyBinding;
import org.lwjgl.input.Keyboard;
import org.lwjgl.opengl.GL11;

import java.util.List;

public final class RenderHelper {

	public static void renderTooltip(int x, int y, List<String> tooltipData) {
		int color = 0x505000ff;
		int color2 = 0xf0100010;

		renderTooltip(x, y, tooltipData, color, color2);
	}

	public static void renderTooltipOrange(int x, int y, List<String> tooltipData) {
		int color = 0x50a06600;
		int color2 = 0xf01e1200;

		renderTooltip(x, y, tooltipData, color, color2);
	}

	public static void renderTooltipGreen(int x, int y, List<String> tooltipData) {
		int color = 0x5000a000;
		int color2 = 0xf0001e00;

		renderTooltip(x, y, tooltipData, color, color2);
	}

	public static void renderTooltip(int x, int y, List<String> tooltipData, int color, int color2) {
		boolean lighting = GL11.glGetBoolean(GL11.GL_LIGHTING);
		if(lighting)
			net.minecraft.client.renderer.RenderHelper.func_74518_a();

		if (!tooltipData.isEmpty()) {
			int var5 = 0;
			int var6;
			int var7;
			FontRenderer fontRenderer = Minecraft.func_71410_x().field_71466_p;
			for (var6 = 0; var6 < tooltipData.size(); ++var6) {
				var7 = fontRenderer.func_78256_a(tooltipData.get(var6));
				if (var7 > var5)
					var5 = var7;
			}
			var6 = x + 12;
			var7 = y - 12;
			int var9 = 8;
			if (tooltipData.size() > 1)
				var9 += 2 + (tooltipData.size() - 1) * 10;
			float z = 300F;
			drawGradientRect(var6 - 3, var7 - 4, z, var6 + var5 + 3, var7 - 3, color2, color2);
			drawGradientRect(var6 - 3, var7 + var9 + 3, z, var6 + var5 + 3, var7 + var9 + 4, color2, color2);
			drawGradientRect(var6 - 3, var7 - 3, z, var6 + var5 + 3, var7 + var9 + 3, color2, color2);
			drawGradientRect(var6 - 4, var7 - 3, z, var6 - 3, var7 + var9 + 3, color2, color2);
			drawGradientRect(var6 + var5 + 3, var7 - 3, z, var6 + var5 + 4, var7 + var9 + 3, color2, color2);
			int var12 = (color & 0xFFFFFF) >> 1 | color & -16777216;
			drawGradientRect(var6 - 3, var7 - 3 + 1, z, var6 - 3 + 1, var7 + var9 + 3 - 1, color, var12);
			drawGradientRect(var6 + var5 + 2, var7 - 3 + 1, z, var6 + var5 + 3, var7 + var9 + 3 - 1, color, var12);
			drawGradientRect(var6 - 3, var7 - 3, z, var6 + var5 + 3, var7 - 3 + 1, color, color);
			drawGradientRect(var6 - 3, var7 + var9 + 2, z, var6 + var5 + 3, var7 + var9 + 3, var12, var12);

			GlStateManager.func_179097_i();
			for (int var13 = 0; var13 < tooltipData.size(); ++var13) {
				String var14 = tooltipData.get(var13);
				fontRenderer.func_175063_a(var14, var6, var7, -1);
				if (var13 == 0)
					var7 += 2;
				var7 += 10;
			}
			GlStateManager.func_179126_j();
		}
		if(!lighting)
			net.minecraft.client.renderer.RenderHelper.func_74518_a();
		GlStateManager.func_179131_c(1F, 1F, 1F, 1F);
	}

	public static void drawGradientRect(int par1, int par2, float z, int par3, int par4, int par5, int par6) {
		float var7 = (par5 >> 24 & 255) / 255F;
		float var8 = (par5 >> 16 & 255) / 255F;
		float var9 = (par5 >> 8 & 255) / 255F;
		float var10 = (par5 & 255) / 255F;
		float var11 = (par6 >> 24 & 255) / 255F;
		float var12 = (par6 >> 16 & 255) / 255F;
		float var13 = (par6 >> 8 & 255) / 255F;
		float var14 = (par6 & 255) / 255F;
		GlStateManager.func_179090_x();
		GlStateManager.func_179147_l();
		GlStateManager.func_179118_c();
		GlStateManager.func_179112_b(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
		GlStateManager.func_179103_j(GL11.GL_SMOOTH);
		Tessellator tessellator = Tessellator.func_178181_a();
		//TODO: Figure out if GetBuffer is the proper replacement for getBuffer
		tessellator.func_178180_c().func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_181706_f);
		tessellator.func_178180_c().func_181662_b(par3, par2, z).func_181666_a(var8, var9, var10, var7).func_181675_d();
		tessellator.func_178180_c().func_181662_b(par1, par2, z).func_181666_a(var8, var9, var10, var7).func_181675_d();
		tessellator.func_178180_c().func_181662_b(par1, par4, z).func_181666_a(var12, var13, var14, var11).func_181675_d();
		tessellator.func_178180_c().func_181662_b(par3, par4, z).func_181666_a(var12, var13, var14, var11).func_181675_d();
		tessellator.func_78381_a();
		GlStateManager.func_179103_j(GL11.GL_FLAT);
		GlStateManager.func_179084_k();
		GlStateManager.func_179141_d();
		GlStateManager.func_179098_w();
	}

	public static void drawTexturedModalRect(int par1, int par2, float z, int par3, int par4, int par5, int par6) {
		drawTexturedModalRect(par1, par2, z, par3, par4, par5, par6, 0.00390625F, 0.00390625F);
	}

	public static void drawTexturedModalRect(int par1, int par2, float z, int par3, int par4, int par5, int par6, float f, float f1) {
		Tessellator tessellator = Tessellator.func_178181_a();
		tessellator.func_178180_c().func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_181707_g);
		tessellator.func_178180_c().func_181662_b(par1 + 0, par2 + par6, z).func_187315_a((par3 + 0) * f, (par4 + par6) * f1).func_181675_d();
		tessellator.func_178180_c().func_181662_b(par1 + par5, par2 + par6, z).func_187315_a((par3 + par5) * f, (par4 + par6) * f1).func_181675_d();
		tessellator.func_178180_c().func_181662_b(par1 + par5, par2 + 0, z).func_187315_a((par3 + par5) * f, (par4 + 0) * f1).func_181675_d();
		tessellator.func_178180_c().func_181662_b(par1 + 0, par2 + 0, z).func_187315_a((par3 + 0) * f, (par4 + 0) * f1).func_181675_d();
		tessellator.func_78381_a();
	}

	public static String getKeyDisplayString(String keyName) {
		String key = null;
		KeyBinding[] keys = Minecraft.func_71410_x().field_71474_y.field_74324_K;
		for(KeyBinding otherKey : keys)
			if(otherKey.func_151464_g().equals(keyName)) {
				key = Keyboard.getKeyName(otherKey.func_151463_i());
				break;
			}

		return key;
	}

	
}
