package xyz.brassgoggledcoders.boilerplate.events;

import net.minecraft.block.Block;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.math.RayTraceResult;
import net.minecraft.world.World;
import net.minecraftforge.event.entity.player.FillBucketEvent;
import net.minecraftforge.fml.common.eventhandler.Event;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;

import java.util.HashMap;
import java.util.Map;

public final class BucketHandler
{
	private static BucketHandler INSTANCE = new BucketHandler();
	public Map<Block, Item> bucketMap = new HashMap<Block, Item>();

	public BucketHandler()
	{
	}

	public static BucketHandler getInstance()
	{
		return INSTANCE;
	}

	@SubscribeEvent
	public void onBucketFill(FillBucketEvent event)
	{
		ItemStack result = this.fillModBucket(event.getWorld(), event.getTarget());
		if(result != null)
		{
			event.setFilledBucket(result);
			event.setResult(Event.Result.ALLOW);
		}

	}

	private ItemStack fillModBucket(World world, RayTraceResult pos)
	{
		Block block = world.func_180495_p(pos.func_178782_a()).func_177230_c();
		Item bucket = this.bucketMap.get(block);

		if ((bucket != null) && (Block.func_176210_f(world.func_180495_p(pos.func_178782_a())) == 0))
		{
			world.func_175698_g(pos.func_178782_a());
			return new ItemStack(bucket);
		}
		else
		{
			return null;
		}
	}
}
