/**
 * This class was created by BrassGoggledCoders modding team.
 * This class is available as part of the BoilerCraft Mod for Minecraft.
 *
 * BoilerCraft is open-source and is distributed under the MMPL v1.0 License.
 * (http://www.mod-buildcraft.com/MMPL-1.0.txt)
 *
 */
package xyz.brassgoggledcoders.boilerplate.utils;

import net.minecraft.block.BlockRailBase;
import net.minecraft.block.BlockRailBase.EnumRailDirection;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

/**
 * @author SkySom
 *
 */
public class BlockUtils
{
	public static boolean isRailBlock(IBlockState blockState)
	{
		boolean isRailBlock;
		isRailBlock = blockState.func_177230_c() instanceof BlockRailBase;
		isRailBlock &= getRailDirection(blockState) != null;
		return isRailBlock;
	}

	public static EnumRailDirection getRailDirection(IBlockState blockState)
	{
		EnumRailDirection railDirection = null;
		if(blockState.func_177230_c() instanceof BlockRailBase)
		{
			BlockRailBase blockRailBase = (BlockRailBase)blockState.func_177230_c();
			railDirection = blockState.func_177229_b(blockRailBase.func_176560_l());
		}
		return railDirection;
	}

	public static boolean canPlayerBreakBlock(World world, EntityPlayer player, BlockPos blockPos)
	{
		return !getBlockUnbreakable(world, blockPos) && player.field_71075_bZ.field_75099_e;
	}

	public static boolean getBlockUnbreakable(World world, BlockPos blockPos)
	{
		IBlockState blockState = world.func_180495_p(blockPos);
		return blockState != null && blockState.func_177230_c().func_176195_g(blockState, world, blockPos) == -1;
	}
}
